Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 135368)
+++ channels/chan_skinny.c	(working copy)
@@ -1823,16 +1823,10 @@
 	return -1; /* main loop will destroy the session */
 }
 
-static int transmit_response(struct skinny_device *d, struct skinny_req *req)
+static int transmit_response_bysession(struct skinnysession *s, struct skinny_req *req)
 {
-	struct skinnysession *s = d->session;
 	int res = 0;
 
-	if (!s) {
-		ast_log(LOG_WARNING, "Asked to transmit to a non-existent session!\n");
-		return -1;
-	}
-
 	ast_mutex_lock(&s->lock);
 
 	if (skinnydebug)
@@ -1864,6 +1858,17 @@
 	return 1;
 }
 
+static int transmit_response(struct skinny_device *d, struct skinny_req *req)
+{
+	struct skinnysession *s = d->session;
+
+	if (!s) {
+		ast_log(LOG_WARNING, "Asked to transmit to a non-existent session!\n");
+		return -1;
+	}
+	return transmit_response_bysession(s,req);
+}
+
 static void transmit_speaker_mode(struct skinny_device *d, int mode)
 {
 	struct skinny_req *req;
@@ -4166,7 +4171,7 @@
 
 static int handle_register_message(struct skinny_req *req, struct skinnysession *s)
 {
-	struct skinny_device *d = NULL;
+	struct skinny_device *d;
 	char name[16];
 	int res;
 
@@ -4179,8 +4184,7 @@
 			return -1;
 
 		snprintf(req->data.regrej.errMsg, sizeof(req->data.regrej.errMsg), "No Authority: %s", name);
-		d->session = s;
-		transmit_response(d, req);
+		transmit_response_bysession(s, req);
 		return 0;
 	}
 	ast_verb(3, "Device '%s' successfully registered\n", name);
